from .AnimatedPlot import AnimatedPlot as _AP
from .DetailRecorder import DetailRecorder as _DR
from .ErrorCal import cal_mse as _c_mse
from .ErrorCal import cal_mae as _c_mae
from .ErrorCal import cal_rmse as _c_rmse
from .ErrorCal import cal_mape as _c_mape
from .ErrorCal import ErrorCal as _EC
from .get_peak import get_peak as _gp
from .var_form import var_form as _vf
from .smoothing import MA_smoothing as _Ms

# AnimatedPlot
class AnimatedPlot(_AP):
	pass

# DetailRecorder
class DetailRecorder(_DR):
	pass

# ErrorCal
def cal_mse(real, predict):
	return _c_mse(real, predict)

def cal_mae(real, predict):
	return _c_mae(real, predict)

def cal_rmse(real, predict):
	return _c_rmse(real, predict)

def cal_mape(real, predict, minima=1e-6):
	return _c_mape(real, predict, minima)

class ErrorCal(_EC):
	pass

# get_peak
def get_peak(data, find_button=False, scan_range=1000):
	return _gp(data, find_button, scan_range)

# var_form
def var_form(var, copy=False):
	return _vf(var, copy)

# smoothing
def MA_smoothing(data, avg_len, smooth_type='middle'):
	return _Ms(data, avg_len, smooth_type)