import numpy as np

def var_form(var, copy=False):
    # This method is made for making variable easily being copied to use in further coding.
    # check list, np.ndarray, tuple
    if type(var) in [list, np.ndarray, tuple]:
        if isinstance(var, list):
            opt_str, end_str = '[', ']'
        elif isinstance(var, np.ndarray):
            opt_str, end_str = 'np.array([', '])'
        elif isinstance(var, tuple):
            opt_str, end_str = '(', ')'

        if len(var) != 0:
            for v in var:
                if isinstance(var, np.ndarray):
                    opt_str += var_form(v.tolist(), copy) + ', '
                else:
                    opt_str += var_form(v, copy) + ', '
            opt_str = opt_str[:-2] + end_str
        else:
            opt_str += end_str

    # check dict
    elif isinstance(var, dict):
        if len(var) != 0:
            opt_str = '{'
            for key, value in var.items():
                opt_str += '{:}: {:}, '.format(var_form(key, copy), var_form(value, copy))
            opt_str = opt_str[:-2] + '}'
        else:
            opt_str = '{}'
    else:
        opt_str = str(var)

    # copy
    if copy:
        try:
            import pyperclip
        except:
            print('The module \'pyperclip\' is needed if copy is True.')
            yn = input('Install? (Y/N) (Execute command: python -m pip install pyperclip)').lower()
            if yn == 'y':
                import os
                os.system('python -m pip install pyperclip')

            import pyperclip

        pyperclip.copy(opt_str)

    return opt_str

def _demo():
    print('This is a demo of var_form.')
    print(var_form(np.ones(5), copy=True))

if __name__ == '__main__':
    _demo()